package bean;

public class TicTacToeGame {
  private char[][] tiles; // game board
  private String winner; // game winner

  public TicTacToeGame() {
    tiles = new char[3][3];
    reset();
  }

  public void handleClick(int row, int col) {
    assert (row > 0 && row < 3 && col > 0 && col < 3);

    boolean didX = false;
    if (!isWinner() && tiles[row][col] == ' ') {
      tiles[row][col] = 'X';
      didX = true;
    }
    if (didX) {
      // see if X won
      for (int r = 0; r < 3; r++) {
        if (tiles[r][0] == 'X' && tiles[r][1] == 'X'
            && tiles[r][2] == 'X') {
          winner = new String("X");
        }
      }
      for (int c = 0; c < 3; c++) {
        if (tiles[0][c] == 'X' && tiles[1][c] == 'X'
            && tiles[2][c] == 'X') {
          winner = new String("X");
        }
      }
      if (tiles[0][0] == 'X' && tiles[1][1] == 'X'
          && tiles[2][2] == 'X') {
        winner = new String("X");
      }
      if (tiles[0][2] == 'X' && tiles[1][1] == 'X'
          && tiles[2][0] == 'X') {
        winner = new String("X");
      }
    }

    // play O
    if (didX && !isWinner()) {
      boolean playable = false;
      for (int r = 0; r < 3; r++)
        for (int c = 0; c < 3; c++) {
          if (tiles[r][c] == ' ') {
            playable = true;
          }
        }
      if (playable) {
        boolean didO = false;
        while (!didO) {
          int r = (int) (Math.random() * 3);
          int c = (int) (Math.random() * 3);
          if (tiles[r][c] == ' ') {
            tiles[r][c] = 'O';
            didO = true;
          }
        }

        // check for "O" win
        for (int r = 0; r < 3; r++) {
          if (tiles[r][0] == 'O' && tiles[r][1] == 'O'
              && tiles[r][2] == 'O') {
            winner = new String("O");
          }
        }
        for (int c = 0; c < 3; c++) {
          if (tiles[0][c] == 'O' && tiles[1][c] == 'O'
              && tiles[2][c] == 'O') {
            winner = new String("O");
          }
        }
        if (tiles[0][0] == 'O' && tiles[1][1] == 'O'
            && tiles[2][2] == 'O') {
          winner = new String("O");
        }
        if (tiles[0][2] == 'O' && tiles[1][1] == 'O'
            && tiles[2][0] == 'O') {
          winner = new String("O");
        }
      }
    }
  }

  public boolean isWinner() {
    return winner.length() > 0;
  }
  
  public void reset() {
    for (int r = 0; r < 3; r++) {
      for (int c = 0; c < 3; c++) {
        tiles[r][c] = ' ';
      }
    }
    winner = new String("");
  }

  public char[][] getTiles() { return tiles; }
  public char getTile(int r, int c) {
    assert (r > 0 && r < 3 && c > 0 && c < 3);
    return tiles[r][c];
  }

  public String getWinner() { return winner; }
  public void setWinner(String winner) {
    this.winner = winner;
  }
}

